#include "global.h"

static LPTSTR szLastKey = NULL;
static int nLastKeyLen = 0;
static TCHAR str_CR[]   = TEXT("\r\n"); // {0x0d,0x0a,0x00};
static TCHAR txt_line[] = TEXT("\r\n----------------------------------\r\n");


int WriteValue(LPTSTR szVal)
{
	LPTSTR scan = szVal;
	DWORD len, outlen=0;

	// We need to escape \ with \\ and " with \"
	while (*scan)
	{
		if (*scan == TEXT('\\'))
		{
			len = (DWORD)(scan-szVal+1);
			WriteFile( hFile, szVal, len * sizeof(TCHAR), &NBW, NULL );
			WriteFile( hFile, TEXT("\\"), sizeof(TCHAR), &NBW, NULL ); 
			szVal = scan + 1;
			outlen += (len+1);
		}
		else if (*scan == TEXT('"'))
		{
			len = (DWORD)(scan-szVal);
			WriteFile( hFile, szVal, len*sizeof(TCHAR), &NBW, NULL );
			WriteFile( hFile, TEXT("\\\""), 2*sizeof(TCHAR), &NBW, NULL ); 
			szVal = scan + 1;
			outlen += (len+2);
		}
		++scan;
	}
	len = (DWORD)(scan - szVal);
	outlen += len;
	if (len != 0) WriteFile( hFile, szVal, len * sizeof(TCHAR), &NBW, NULL );
	return outlen;
}

void SaveLastKey(LPTSTR szKey, int len)
{
	if (len > nLastKeyLen)
	{
		if (szLastKey != NULL) MYFREE(szLastKey);
		szLastKey = (LPTSTR)MYALLOC((len+1)*sizeof(TCHAR));
		nLastKeyLen = len;
	}
	_tcscpy(szLastKey, szKey);
}

void WriteRegHeader()
{
		WriteFile(hFile, txt_line, sizeof(txt_line)-sizeof(TCHAR), &NBW, NULL);
		WriteFile( hFile, TEXT("\r\nREGEDIT4\r\n"), 12*sizeof(TCHAR), &NBW, NULL );
}

void WriteSpaces(DWORD count)
{
	DWORD i;
	for (i = 0; i < count; ++i)
	{
		WriteFile( hFile, TEXT(" "), sizeof(TCHAR), &NBW, NULL );
	}
}

void WriteNewLine()
{
	WriteFile(hFile,str_CR,sizeof(str_CR)-sizeof(TCHAR),&NBW,NULL); 
}

DWORD WriteRegKey(LPTSTR keyName, BOOL isDel)
{

	DWORD nLen = (DWORD)_tcslen( keyName );
	WriteNewLine();
	WriteFile( hFile, TEXT("["), sizeof(TCHAR), &NBW, NULL );
	if (isDel)
		WriteFile(hFile, TEXT("-"), sizeof(TCHAR), &NBW, NULL);
	WriteFile( hFile, keyName, nLen * sizeof(TCHAR), &NBW, NULL );
	WriteFile( hFile, TEXT("]"), sizeof(TCHAR), &NBW, NULL );
	WriteNewLine();
	return nLen;
}

VOID CreateNewResultReg(DWORD nActionType, LPVOID lpContentOld, LPVOID lpContentNew)
{
    LPCOMPRESULT lpCR;
    LPCOMPRESULTREG lpCRREG;

    switch (nActionType) {
        case KEYDEL:
        case KEYADD:
        case VALDEL:
        case VALADD:
        case VALMODI:
			lpCRREG = (LPCOMPRESULTREG)MYALLOC0(sizeof(COMPRESULTREG));
			lpCRREG->lpContentOld = lpContentOld;
			lpCRREG->lpContentNew = lpContentNew;
			lpCRREG->nActionType = nActionType;
            if (NULL == CompareResult.lpChangedHead)
				CompareResult.lpChangedHead = lpCRREG;
			else
				CompareResult.lpChangedCurrent->lpNextCR = lpCRREG;
            CompareResult.lpChangedCurrent = lpCRREG;
            break;
        case DIRDEL:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRDirDeleted) ? (CompareResult.stCRHeads.lpCRDirDeleted = lpCR) : (CompareResult.stCRCurrent.lpCRDirDeleted->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRDirDeleted = lpCR;
            break;
        case DIRADD:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRDirAdded) ? (CompareResult.stCRHeads.lpCRDirAdded = lpCR) : (CompareResult.stCRCurrent.lpCRDirAdded->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRDirAdded = lpCR;
            break;
        case DIRMODI:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRDirModified) ? (CompareResult.stCRHeads.lpCRDirModified = lpCR) : (CompareResult.stCRCurrent.lpCRDirModified->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRDirModified = lpCR;
            break;
        case FILEDEL:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRFileDeleted) ? (CompareResult.stCRHeads.lpCRFileDeleted = lpCR) : (CompareResult.stCRCurrent.lpCRFileDeleted->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRFileDeleted = lpCR;
            break;
        case FILEADD:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRFileAdded) ? (CompareResult.stCRHeads.lpCRFileAdded = lpCR) : (CompareResult.stCRCurrent.lpCRFileAdded->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRFileAdded = lpCR;
            break;
        case FILEMODI:
			lpCR = (LPCOMPRESULT)MYALLOC0(sizeof(COMPRESULT));
			lpCR->lpContentOld = lpContentOld;
			lpCR->lpContentNew = lpContentNew;
            (NULL == CompareResult.stCRHeads.lpCRFileModified) ? (CompareResult.stCRHeads.lpCRFileModified = lpCR) : (CompareResult.stCRCurrent.lpCRFileModified->lpNextCR = lpCR);
            CompareResult.stCRCurrent.lpCRFileModified = lpCR;
            break;
	}

}

static void CheckUpdateUI()
{
    // Increase count
    cCurrent++;

    // Update progress bar display
    if (0 != cEnd) {
        DWORD nCurrentTime = GetTickCount();
        if (REFRESHINTERVAL < (nCurrentTime - nLastTime)) {
            UI_UpdateProgressBar();
        }
    }
}

static void WriteValueContent(LPVALUECONTENT lpValueContent, DWORD outlen)
{
	TCHAR lpvaluedata[85];
	DWORD c, size = lpValueContent->cbData;
	switch ( lpValueContent->nTypeCode )
	{

	case REG_SZ:
	case REG_EXPAND_SZ: // AMB : no reason not to treat the same
		WriteFile( hFile, TEXT("\""), sizeof(TCHAR), &NBW, NULL ); 
		if (NULL != lpValueContent->lpValueData) 
			WriteValue((LPTSTR)lpValueContent->lpValueData);
		WriteFile( hFile, TEXT("\""), sizeof(TCHAR), &NBW, NULL ); 
		WriteNewLine();
		break;

	case REG_DWORD:
		//case REG_DWORD_BIG_ENDIAN: Not used any more,they all included in [default]
		if (NULL != lpValueContent->lpValueData)	
		{
			_sntprintf( lpvaluedata, 85, TEXT("dword:%08X"), *( LPDWORD ) ( lpValueContent->lpValueData ) );
			WriteFile( hFile, lpvaluedata, 14*sizeof(TCHAR), &NBW, NULL ); 
			WriteNewLine();
		}
		else
		{
			WriteFile( hFile, TEXT("hex(4):"), 7*sizeof(TCHAR), &NBW, NULL);
			WriteNewLine();
		}
		break;

	default :
		if (size)
		{
			int len = 9;
			outlen += 9;
			_sntprintf( lpvaluedata, 85, TEXT("hex(%01x):%02X"), lpValueContent->nTypeCode, *( lpValueContent->lpValueData ) );
			//for the resttype lengthofvaluedata doesn't contains the 0!
			for ( c = 1;c < size;c++ )
			{
				if (outlen > 77)
				{
					WriteFile( hFile, lpvaluedata, len*sizeof(TCHAR), &NBW, NULL ); 
					WriteFile( hFile, TEXT(",\\"), 2*sizeof(TCHAR), &NBW, NULL );
					WriteNewLine();
					outlen = 4;
					len = _sntprintf( lpvaluedata, 85, TEXT("  %02X"), *( lpValueContent->lpValueData + c ) );
				}
				else
				{
					_sntprintf( &lpvaluedata[len], 85, TEXT(",%02X"), *( lpValueContent->lpValueData + c ) );
					outlen += 3;
					len += 3;
				}
			}
			WriteFile( hFile, lpvaluedata, len*sizeof(TCHAR), &NBW, NULL ); 
			WriteNewLine();
		}
		else
		{
			int len = wsprintf( lpvaluedata, TEXT("hex(%01x):"), lpValueContent->nTypeCode);
			WriteFile( hFile, lpvaluedata, len*sizeof(TCHAR), &NBW, NULL );
			WriteNewLine();
		}
	}

}

VOID WritePartReg(LPCOMPRESULTREG lpStartCR)
{
    LPTSTR lpszResult;
    LPCOMPRESULTREG lpCR;
	LPVALUECONTENT lpVal = NULL;
    DWORD cbCRLF;
	DWORD len, outlen;

	if (NULL == lpStartCR)
		return;

	WriteRegHeader();

    cbCRLF = 0;

    cbCRLF = (DWORD)(_tcslen(lpszCRLF) * sizeof(TCHAR));

    for (lpCR = lpStartCR; NULL != lpCR; lpCR = lpCR->lpNextCR, CheckUpdateUI()) {
		switch(lpCR->nActionType)
		{
		case KEYADD:
			lpszResult = GetWholeKeyName((LPKEYCONTENT)lpCR->lpContentNew, fUseLongRegHead);
			len = WriteRegKey(lpszResult, FALSE);
			SaveLastKey(lpszResult, len);
            MYFREE(lpszResult);
			continue;

		case KEYDEL:
			lpszResult = GetWholeKeyName((LPKEYCONTENT)lpCR->lpContentOld, fUseLongRegHead);
			WriteRegKey(lpszResult, TRUE);
			if (szLastKey) szLastKey[0] = 0;
            MYFREE(lpszResult);
			continue;

		case VALADD:
			lpVal = (LPVALUECONTENT)lpCR->lpContentNew;
			break;

		case VALDEL:
			lpVal = (LPVALUECONTENT)lpCR->lpContentOld;
			break;

		case VALMODI:
			lpVal = (LPVALUECONTENT)lpCR->lpContentNew;
			break;

		}
        lpszResult = GetWholeKeyName(lpVal->lpFatherKC, fUseLongRegHead);
		if (szLastKey == NULL || _tcsicmp(lpszResult,szLastKey) != 0)
		{
			len = WriteRegKey(lpszResult, FALSE);
			SaveLastKey(lpszResult, len);
		}
        MYFREE(lpszResult);

		lpszResult = lpVal->lpszValueName;
        if (lpszResult == NULL)
            len = 0;
        else
		    len = (DWORD)_tcslen(lpszResult);
		if (len == 0)
		{
			WriteFile( hFile, TEXT("@="), 2*sizeof(TCHAR), &NBW, NULL ); 
			outlen = 2;
		}
		else
		{
			WriteFile( hFile, TEXT("\""), sizeof(TCHAR), &NBW, NULL ); 
			outlen = WriteValue(lpszResult) + 3;
			WriteFile( hFile, TEXT("\"="), 2*sizeof(TCHAR), &NBW, NULL ); 
		}

		if (lpCR->nActionType == VALDEL)
		{
			WriteFile( hFile, TEXT("-"), sizeof(TCHAR), &NBW, NULL ); //this!
			WriteNewLine();
		}
		else
		{
			WriteValueContent(lpVal, outlen);
		}
    }

}







